function [dy1,sd,err]=smooth1(n,eps1,dx,dy,w)

%c input    n(i4) number of points;
% c input  eps1(r4) degree of smoothing;
%c input   dx(r8) arguments;
% function [valuesResult]=values(varargin);
% valuesResult=[];

% c output  sd(r4) standard deviation;
% c output err(l4) indication of rough error;
% c(c) j. vondrak, june 1999;
% if isempty(d), d=0; end;
d = 0;
% if isempty(w), w=(ones(1,:)); end;
%if isempty(dy), dy=(ones(1,:)); end;
%f isempty(dy1), dy1=(ones(1,:)); end;
%if isempty(da), da=(ones(7000,4)); end;
%if isempty(db), db=(ones(1,4)); end;
%if isempty(dp), dp=(ones(4,4)); end;
%if isempty(err), err=false; end;
da = (ones(7000,4));
db=(ones(1,4));
dp=(ones(4,4));    
err=false;

function dpar=dpar(dxx), dpar=dp1+dxx.*(dp2+dxx.*dp3); end

if(n>7000 || n<3),return, end;

% estimation of parabolic fit;
dxo=(.5.*(dx(1)+dx(n))); % fijando baricentro
dp=(zeros(4,4));
db=(ones(1,4));
for i=1:n; % las siguientes sentencias aplican baricentro y preparan calculo de 
    dxi=dx(i)-dxo; % y sombrero, ec. 11 del paper.
    dy1(i)=0; % inicializa dy1 de i.
    db(2)=dxi;
    db(3)=dxi.*dxi;
    db(4)=dy(i); % valor observado en instante i.
    for j=1:3;
        for k=1:4;
            dp(j,k)=dp(j,k)+w(i).*db(j).*db(k);
        end;
    end;
end;
for j=1:3;
    dp1=dp(1,j);
    for k=j+1:4;
        dp2=dp(1,k);
        for i=1:2;
            dp(i,k)=dp(i+1,k)-dp(i+1,j).*dp2./dp1;
        end;
        dp(3,k)=dp2./dp1;
    end;
end;
dp1=dp(1,4);
dp2=dp(2,4);
dp3=dp(3,4);
% Parece que definitivamente los valores dp(i,j) son coef. de las ec. al
% aplicar rms.
if(eps1==0.), return, end %goto 10; 
% end;
% forming the equations;
da=zeros(7000,4);
o=eps1./(n-3);
for i=1:n;
    da(i,1)=o.*w(i); % parece representar los B_i pag. 353, aunque sobra dividir entre n-3.
    dy1(i)=da(i,1).*(dy(i)-dpar(dx(i)-dxo)); % dy1 tiene pinta de representar 2 miembro de (11)
end;
ddx=dx(n)-dx(1); % amplitud o rango de la variable independiente
for i=1:n-3;
    ds=36.*(dx(i+2)-dx(i+1))./ddx; % numerador de a, b, c y d escalado.
    for j=1:4;
        db(j)=1d0;
        for k=1:4;
            if(k~=j)
                db(j)=db(j)./(dx(i+j-1)-dx(i+k-1));
            end;
        end;
    end;
    for j=1:4;
        for k=j:4;
            da(i+j-1,k-j+1)=da(i+j-1,k-j+1)+ds.*db(j).*db(k);
        end;
    end;
end;
% solution of the equations;
% initialization of array dp;
for j=1:3;
    for k=1:j;
        dp(j,k)=da(k,j-k+2);
    end;
end;
% reduction of matrix da to an upper triangular matrix;
for i=1:n-1;
    n3=min([3,n-i]);
    dy1(i)=dy1(i)./da(i,1);
    for j=2:n3+1;
        da(i,j)=da(i,j)./da(i,1);
    end;
    for j=1:n3;
        dy1(i+j)=dy1(i+j)-dy1(i).*dp(j,1);
        for k=1:n3-j+1;
            da(i+j,k)=da(i+j,k)-da(i,k+j).*dp(j,1);
        end;
    end;
    dp(1,1)=dp(2,2)-da(i,2).*dp(2,1);
    dp(2,1)=dp(3,2)-da(i,2).*dp(3,1);
    dp(2,2)=dp(3,3)-da(i,3).*dp(3,1);
    dp(3,1)=da(i+1,4);
    if(i<=n-2)
        dp(3,2)=da(i+2,3);
    end;
    if(i<=n-3)
        dp(3,3)=da(i+3,2);
    end;
end;
% calculation of the unknowns;
dy1(n)=dy1(n)./da(n,1);
for i=1:n-1;
    k=n-i+1;
    n3=min([3,n-i]);
    for j=1:n3;
        dy1(k-j)=dy1(k-j)-da(k-j,j+1).*dy1(k);
    end;
end;
% estimation of sigma, detection of rough errors;
sd=0.;
for i=1:n;
    dy1(i)=dy1(i)+dpar(dx(i)-dxo);
    sd=sd+w(i).*(dy1(i)-dy(i)).^2;
end;
if(n<=3), return, end,
sd=sqrt(sd./(n-3));
err=false;
for i=1:n;
    if(sqrt(w(i)).*abs(dy1(i)-dy(i))>3.5.*sd)
        err=true;
    end;
end;
return;
end




% function [argStr,status]=getarg(n,argStr,status)
% %replicates getarg in fortran
% global GlobInArgs nargs
% if n<0 || n>nargs
%  argStr=''; status=-1;
% else
%  argStr=GlobInArgs{n+1};
%  status=length(argStr);
% end
% end